import 'package:shared_preferences/shared_preferences.dart';

class User {
  String? token;

  void saveToken() async {
    final SharedPreferences prefs = await SharedPreferences.getInstance();
    prefs.setString('token', token ?? '');
  }

  static Future<String?> getToken() async {
    final SharedPreferences prefs = await SharedPreferences.getInstance();
    return prefs.getString('token');
  }
}

class Auth<T extends User> {
  factory Auth() {
    return _singleton as Auth<T>;
  }

  Auth._internal();
  static final Auth<User> _singleton = Auth<User>._internal();
  T? _user;

  void authenticate(T user) {
    _user = user;
  }

  void unauthenticated() {
    _user = null;
  }

  T? user() {
    return _user;
  }
}
