import 'dart:async';
import 'dart:ui';

class Message<T> {
  Message(this.key, this.data);
  String key;
  T data;
}

class BusService {
  StreamController<Message<dynamic>> bus =
      StreamController<Message<dynamic>>.broadcast();

  void sendMessage(Message<dynamic> message) {
    bus.sink.add(message);
  }

  void listenMessageWithKey(String key, VoidCallback onCallBack) {
    bus.stream.listen((Message<dynamic> event) {
      if (event.key == key) {
        onCallBack();
      }
    });
  }
}
